with System;

with Interruptions;                    use Interruptions;

with Bios;                             use Bios;

with Text_IO;                          use Text_IO;
with Integer_IO;                       use Integer_IO;

with Machine_Code;                     use Machine_Code;

procedure Interruption_count is
  Ul : constant Integer := Video_Out_Screen + Character'Pos ( '_' );
  Sp : constant Integer := Video_Out_Screen + Character'Pos ( ' ' );
  Count_05 : Integer := 0;
  Count_10 : Integer := 0;
  Count_21 : Integer := 0;
  task T is
      pragma Priority ( 2 );
    entry Start;
    entry Int_05;
    entry Int_10 ( S : State_Point );
    entry Int_21;
    for Int_05 use at 16#05#;
    for Int_10 use at 16#10#;
    for Int_21 use at 16#21#;
  end T;
  task E is
      pragma Priority ( 2 );
    entry Int_EE;
    for Int_EE use at 16#EE#;
  end E;
  task body T is
  begin
    accept Start;
    loop
      select
        accept Int_05 do
          Count_05 := Count_05 + 1;
        end Int_05;
      or
        accept Int_10 ( S : State_Point ) do
          Count_10 := Count_10 + 1;
          if    S.General.Eax = Ul then
            S.General.Eax := Sp;
          end if;
        end Int_10;
      or
        accept Int_21 do
          Count_21 := Count_21 + 1;
        end Int_21;
      end select;
    end loop;
  end T;
  task body E is
  begin
    accept Int_EE do
      Put_Line ( "Int_EE" );
      Abort_Interrupted_Task;
    end Int_EE;
  end E;
begin
  Put_Line ( "_Interruption_count_" );
  T.Start;
  Put_Line ( "_Interruption_count_" );
  for I in 1 .. 100 loop
    declare
      I : Integer range 1 .. 100;
    begin
      I := 0;
    exception
      when Constraint_Error =>
        null;
    end;
  end loop;
  abort T;
  Put_Line ( "_Interruption_count_" );
  Put ( "Count_05 :" );
  Put ( Count_05 );
  New_Line;
  Put ( "Count_10 :" );
  Put ( Count_10 );
  New_Line;
  Put ( "Count_21 :" );
  Put ( Count_21 );
  New_Line;
  Int ( Imm ( 16#EE# - 256 ) );
end Interruption_count;
