with Kbd_BIOS;                         use Kbd_BIOS;
with Full_Screen_IO;                   use Full_Screen_IO;
with Coding;                           use Coding;
with Display;

procedure Kbd_Test is

  subtype Horisontal is Display.Horisontal;
  subtype Vertical is Display.Vertical;

  Space : String ( 1 .. 80 ) := ( others => ' ' );

  E : Boolean;

  Count : Integer := 0;
  Pc, Ps : Integer := 0;

  procedure Frame_Display is
  begin
    Clear_Screen ( Blue, Light_Gray );
    Set_Screen_Position ( 1, 1 );
    for I in Vertical loop
      Put ( Character'Val ( 16#CD# ) );
    end loop;
    Set_Screen_Position ( 7, 1 );
    for I in Vertical loop
      Put ( Character'Val ( 16#CD# ) );
    end loop;
    Set_Screen_Position ( Horisontal'Last, 1 );
    for I in Vertical loop
      Put ( Character'Val ( 16#CD# ) );
    end loop;
    Set_Screen_Position ( 17, 2 );
    for I in 2 .. 39  loop
      Put ( Character'Val ( 16#CD# ) );
    end loop;
    for I in Horisontal loop
      Set_Screen_Position ( I, 1 );
      Put ( Character'Val ( 16#BA# ) );
      Set_Screen_Position ( I, Vertical'Last );
      Put ( Character'Val ( 16#BA# ) );
    end loop;
    for I in 7 .. Horisontal'Last loop
      Set_Screen_Position ( I, 40 );
      Put ( Character'Val ( 16#BA# ) );
    end loop;
    Set_Screen_Position ( 1, 1 );
    Put ( Character'Val ( 16#C9# ) );
    Set_Screen_Position ( 1, Vertical'Last );
    Put ( Character'Val ( 16#BB# ) );
    Set_Screen_Position ( 7, 1 );
    Put ( Character'Val ( 16#CC# ) );
    Set_Screen_Position ( 7, 40 );
    Put ( Character'Val ( 16#CB# ) );
    Set_Screen_Position ( 7, Vertical'Last );
    Put ( Character'Val ( 16#B9# ) );
    Set_Screen_Position ( 17, 1 );
    Put ( Character'Val ( 16#CC# ) );
    Set_Screen_Position ( 17, 40 );
    Put ( Character'Val ( 16#B9# ) );
    Set_Screen_Position ( Horisontal'Last, 1 );
    Put ( Character'Val ( 16#C8# ) );
    Set_Screen_Position ( Horisontal'Last, 40 );
    Put ( Character'Val ( 16#CA# ) );
    Set_Screen_Position ( Horisontal'Last, Vertical'Last );
    Put ( Character'Val ( 16#BC# ) );
    Set_Background_Color ( Black );
    Set_Text_Color ( Light_Magenta );
    Set_Screen_Position ( 3, 28 );
    Put ( "                     " );
    Set_Screen_Position ( 4, 28 );
    Put ( "   Kbd_BIOS   Test   " );
    Set_Screen_Position ( 5, 28 );
    Put ( "                     " );
    Set_Background_Color ( Blue );
    Set_Text_Color ( Light_Gray );
    Set_Screen_Position ( 9, 5 );
    Put ( "ASCII_character   " );
    Set_Screen_Position ( 11, 5 );
    Put ( "ASCII_character_code   " );
    Set_Screen_Position ( 13, 5 );
    Put ( "Scan_code        " );
    Set_Screen_Position ( 15, 5 );
    Put ( "Count            " );
    Set_Screen_Position ( 21, 12 );
    Put ( "Exit : Alt+Alt+X" );
  end Frame_Display;

  procedure Invisible_Display is
  begin
    case ASCII_character is
      when Ascii.Soh =>
        Put ( "SOH" );
      when Ascii.Stx =>
        Put ( "STX" );
      when Ascii.Etx =>
        Put ( "ETX" );
      when Ascii.Eot =>
        Put ( "EOT" );
      when Ascii.Enq =>
        Put ( "ENQ" );
      when Ascii.Ack =>
        Put ( "ACK" );
      when Ascii.Bel =>
        Put ( "BEL" );
      when Ascii.Bs =>
        Put ( "BS " );
      when Ascii.Ht =>
        Put ( "HT " );
      when Ascii.Lf =>
        Put ( "LF " );
      when Ascii.Vt =>
        Put ( "VT " );
      when Ascii.Ff =>
        Put ( "FF " );
      when Ascii.Cr =>
        Put ( "CR " );
      when Ascii.So =>
        Put ( "SO " );
      when Ascii.Si =>
        Put ( "SI " );
      when Ascii.Dle =>
        Put ( "DLE" );
      when Ascii.Dc1 =>
        Put ( "DC1" );
      when Ascii.Dc2 =>
        Put ( "DC2" );
      when Ascii.Dc3 =>
        Put ( "DC3" );
      when Ascii.Dc4 =>
        Put ( "DC4" );
      when Ascii.Nak =>
        Put ( "NAK" );
      when Ascii.Syn =>
        Put ( "SYN" );
      when Ascii.Etb =>
        Put ( "ETB" );
      when Ascii.Can =>
        Put ( "CAN" );
      when Ascii.Em =>
        Put ( "EM " );
      when Ascii.Sub =>
        Put ( "SUB" );
      when Ascii.Esc =>
        Put ( "ESC" );
      when Ascii.Fs =>
        Put ( "FS " );
      when Ascii.Gs =>
        Put ( "GS " );
      when Ascii.Rs =>
        Put ( "RS " );
      when Ascii.Us =>
        Put ( "US " );
      when Ascii.Del =>
        Put ( "DEL" );
      when others =>
        null;
    end case;
  end Invisible_Display;

  procedure Key_Display is
  begin
    Get_Key;
    if    Pc /= ASCII_character_code or else Ps /= Scan_code then
      Set_Screen_Position ( 9, 29 );
      case ASCII_character_code is
        when 16#00# | 16#E0# =>
          Set_Background_Color ( Black );
          Set_Text_Color ( Black );
          Put ( "   " );
        when others =>
          Set_Background_Color ( Blue );
          Set_Text_Color ( White );
          if    not Is_Visible ( ASCII_character ) then
            Invisible_Display;
          else
            Put ( ' ' & ASCII_character & ' ' );
          end if;
      end case;
      Set_Background_Color ( Blue );
      Set_Text_Color ( White );
      Set_Screen_Position ( 11, 30 );
      Put ( Hex_Digit ( ASCII_character_code / 16 ) );
      Put ( Hex_Digit ( ASCII_character_code mod 16 ) );
      Set_Screen_Position ( 13, 30 );
      Put ( Hex_Digit ( Scan_code / 16 ) );
      Put ( Hex_Digit ( Scan_code mod 16 ) );
      Pc := ASCII_character_code;
      Ps := Scan_code;
      Count := 0;
    end if;
    Count := Count + 1;
    Set_Background_Color ( Blue );
    Set_Text_Color ( White );
    Set_Screen_Position ( 15, 22 );
    Put ( Space ( 1 .. 10 - Integer'Image ( Count )'Length ) );
    Put ( Integer'Image ( Count ) );
  end Key_Display;

  procedure Test_Shift ( P, L, R : Boolean;
                         S : String;
                         N : Integer ) is
  begin
    Set_Screen_Position ( N, 54 );
    if    L then
      Set_Background_Color ( Red );
    else
      Set_Background_Color ( Blue );
    end if;
    Put ( " " );
    Set_Screen_Position ( N, 56 );
    if    P then
      Set_Background_Color ( Cyan );
      Set_Text_Color ( Light_Red );
    else
      Set_Background_Color ( Black );
      Set_Text_Color ( Light_Gray );
    end if;
    Put ( " " & S & " " );
    Set_Screen_Position ( N, 64 );
    if    R then
      Set_Background_Color ( Green );
    else
      Set_Background_Color ( Blue );
    end if;
    Put ( " " );
  end Test_Shift;

  procedure Test_Lock ( P, L : Boolean;
                        S : String;
                        N : Integer ) is
  begin
    Set_Screen_Position ( N, 55 );
    if    L then
      Set_Background_Color ( Cyan );
    else
      Set_Background_Color ( Black );
    end if;
    if    P then
      Set_Text_Color ( Light_Red );
    else
      if    L then
        Set_Text_Color ( Yellow );
      else
        Set_Text_Color ( Light_Gray );
      end if;
    end if;
    Put ( " " & S & " " );
  end Test_Lock;

  procedure Key_Status_Display is
  begin
    Key_Status;
    Test_Shift ( Shift_key_pressed,
                 Left_Shift_key_pressed,
                 Right_Shift_key_pressed,
                 "Shift", 9 );
    Test_Shift ( Ctrl_key_pressed,
                 Left_Ctrl_key_pressed,
                 Right_Ctrl_key_pressed,
                 "Ctrl ", 11 );
    Test_Shift ( Alt_key_pressed,
                 Left_Alt_key_pressed,
                 Right_Alt_key_pressed,
                 " Alt ", 13 );
    Test_Shift ( SysRq_key_pressed, False, False, "SysRq", 15 );
    Test_Lock (               False,      Insert_locked, "  Insert   ", 17 );
    Test_Lock (   Caps_Lock_pressed,   Caps_Lock_locked, " Caps_Lock ", 19 );
    Test_Lock (    Num_Lock_pressed,    Num_Lock_locked, "  Num_Lock ", 21 );
    Test_Lock ( Scroll_Lock_pressed, Scroll_Lock_locked, "Scroll_Lock", 23 );
  end Key_Status_Display;

begin
  Set_Cursor_Size ( 14, 13 );
  Frame_Display;
  loop
    E := False;
    if    Key_Pressed then
      Key_Display;
      E := ASCII_character_code = 0 and then Scan_code = 16#2D#;
    end if;
    Key_Status_Display;
    exit when E and then Left_Alt_key_pressed and then Right_Alt_key_pressed;
  end loop;
end Kbd_Test;
