package Random_Numbers is

  procedure SeedRand ( S : Integer );

  function Random ( R : Integer ) return Integer;
  function Random return Float;

end Random_Numbers;
with Calendar;
use Calendar;

package body Random_Numbers is

  procedure Seedrand ( S : Integer ) is
  begin
    null;
  end Seedrand;

  function Random ( R : Integer ) return Integer is
  begin
    return ( Integer ( Float ( Seconds ( Clock ) ) * 256.0 ) ) mod R;
  end Random;

  function Random return Float is
  begin
    return Float ( 99 - Random ( 100 ) ) * 0.001;
  end Random;

end Random_Numbers;
with Random_Numbers;                   use Random_Numbers;

with Full_Screen_IO;                   use Full_Screen_IO;

with Profiler, Keyboard, Calendar, Display, Integer_IO, Float_IO;

procedure Profiler_Test is

  subtype Horisontal is Display.Horisontal;
  subtype Vertical is Display.Vertical;

  Random_Error : exception;
  Rng : Positive := 100;
  Seed : Positive := 12345;
  S, T : Calendar.Day_Duration;
  Signal : Character := Ascii.Nul;

  procedure Proc0 is
  begin
    null;
  end Proc0;

  procedure Proc1 is
  begin
    Proc0;
  end Proc1;

  procedure Proc2 is
  begin
    Proc1;
  end Proc2;

  procedure Proc3 is
  begin
    Proc2;
  end Proc3;

  procedure Frame_Display is
  begin
    Clear_Screen ( Blue, Light_Gray );
    Set_Screen_Position ( 1, 1 );
    for I in Vertical loop
      Put ( Character'Val ( 16#CD# ) );
    end loop;
    Set_Screen_Position ( 7, 1 );
    for I in Vertical loop
      Put ( Character'Val ( 16#CD# ) );
    end loop;
    Set_Screen_Position ( 11, 40 );
    for I in 40 .. Vertical'Last loop
      Put ( Character'Val ( 16#CD# ) );
    end loop;
    Set_Screen_Position ( 17, 40 );
    for I in 40 .. Vertical'Last loop
      Put ( Character'Val ( 16#CD# ) );
    end loop;
    Set_Screen_Position ( Horisontal'Last, 1 );
    for I in Vertical loop
      Put ( Character'Val ( 16#CD# ) );
    end loop;
    for I in Horisontal loop
      Set_Screen_Position ( I, 1 );
      Put ( Character'Val ( 16#BA# ) );
      Set_Screen_Position ( I, Vertical'Last );
      Put ( Character'Val ( 16#BA# ) );
    end loop;
    for I in 7 .. Horisontal'Last loop
      Set_Screen_Position ( I, 40 );
      Put ( Character'Val ( 16#BA# ) );
    end loop;
    Set_Screen_Position ( 1, 1 );
    Put ( Character'Val ( 16#C9# ) );
    Set_Screen_Position ( 1, Vertical'Last );
    Put ( Character'Val ( 16#BB# ) );
    Set_Screen_Position ( 7, 1 );
    Put ( Character'Val ( 16#CC# ) );
    Set_Screen_Position ( 7, 40 );
    Put ( Character'Val ( 16#CB# ) );
    Set_Screen_Position ( 7, Vertical'Last );
    Put ( Character'Val ( 16#B9# ) );
    Set_Screen_Position ( 11, 40 );
    Put ( Character'Val ( 16#CC# ) );
    Set_Screen_Position ( 11, Vertical'Last );
    Put ( Character'Val ( 16#B9# ) );
    Set_Screen_Position ( 17, 40 );
    Put ( Character'Val ( 16#CC# ) );
    Set_Screen_Position ( 17, Vertical'Last );
    Put ( Character'Val ( 16#B9# ) );
    Set_Screen_Position ( Horisontal'Last, 1 );
    Put ( Character'Val ( 16#C8# ) );
    Set_Screen_Position ( Horisontal'Last, 40 );
    Put ( Character'Val ( 16#CA# ) );
    Set_Screen_Position ( Horisontal'Last, Vertical'Last );
    Put ( Character'Val ( 16#BC# ) );
    Set_Background_Color ( Black );
    Set_Text_Color ( Light_Magenta );
    Set_Screen_Position ( 3, 28 );
    Put ( "                     " );
    Set_Screen_Position ( 4, 28 );
    Put ( "   Profiler   Test   " );
    Set_Screen_Position ( 5, 28 );
    Put ( "                     " );
    Set_Background_Color ( Blue );
    Set_Text_Color ( Light_Gray );
    Set_Screen_Position ( 9, 5 );
    Put ( "Exit                => Esc" );
    Set_Screen_Position ( 11, 5 );
    Put ( "Profiler   On       => +" );
    Set_Screen_Position ( 13, 5 );
    Put ( "Profiler   Off      => -" );
    Set_Screen_Position ( 15, 5 );
    Put ( "Profiler   Clear    => /" );
    Set_Screen_Position ( 17, 5 );
    Put ( "Profiler   Print    => =" );
    Set_Screen_Position ( 19, 5 );
    Put ( "Change seed         => s" );
    Set_Screen_Position ( 21, 5 );
    Put ( "Change range        => r" );
    Set_Screen_Position ( 9, 50 );
    Put ( "Profiler" );
    Set_Screen_Position ( 13, 50 );
    Put ( "Seed" );
    Set_Screen_Position ( 15, 50 );
    Put ( "Range    0 .." );
    Set_Screen_Position ( 19, 50 );
    Put ( "Integer" );
    Set_Screen_Position ( 21, 45 );
    Put ( "Float" );
  end Frame_Display;

  procedure Profiler_Display ( On : Boolean ) is
      pragma Debugging ( Off );
  begin
    Set_Screen_Position ( 9, 61 );
    if    On then
      Set_Background_Color ( White );
      Set_Text_Color ( Light_Red );
      Put ( " On " );
    else
      Set_Background_Color ( Blue );
      Set_Text_Color ( Light_Gray );
      Put ( " Off" );
    end if;
  end Profiler_Display;

  procedure Random_Display is
      pragma Debugging ( Off );
    F : String ( 1 .. 24 );
  begin
    Set_Background_Color ( Blue );
    Set_Text_Color ( Light_Gray );
    Set_Screen_Position ( 13, 60 );
    Put ( "           " );
    Set_Screen_Position ( 13, 60 );
    Put ( Integer'Image ( Seed ) );
    Set_Screen_Position ( 15, 63 );
    Put ( "           " );
    Set_Screen_Position ( 15, 63 );
    Put ( Integer'Image ( Rng - 1 ) );
    Set_Screen_Position ( 19, 60 );
    Put ( "           " );
    Set_Screen_Position ( 19, 60 );
    Put ( Integer'Image ( Random ( Rng ) ) );
    Set_Screen_Position ( 21, 50 );
    Float_IO.Put ( F, Random );
    Put ( F );
  end Random_Display;

  procedure Change_Seed is
      pragma Debugging ( Off );
  begin
    Integer_IO.Get ( Seed );
    SeedRand ( Seed );
  end Change_Seed;

  procedure Change_Range is
      pragma Debugging ( Off );
  begin
    Integer_IO.Get ( Rng );
  end Change_Range;

begin
  S := Calendar.Seconds ( Calendar.Clock );
  Set_Cursor_Size ( 1, 0 );
  Frame_Display;
  Profiler_Display ( False );
  loop
    if    Keyboard.Key_Pressed then
      Signal := Keyboard.Get_Key;
      case Signal is
        when '+' =>
          Profiler.On;
          Profiler_Display ( True );
        when '-' =>
          Profiler.Off;
          Profiler_Display ( False );
        when '/' =>
          Profiler.Clear;
        when '=' =>
          Profiler.Print;
        when 's' | 'S' =>
          Change_Seed;
        when 'r' | 'R' =>
          Change_Range;
        when Ascii.Esc =>
          exit;
        when others =>
          null;
      end case;
    end if;
    case Random ( 4 ) is
      when 0 =>
        Proc0;
      when 1 =>
        Proc1;
      when 2 =>
        Proc2;
      when 3 =>
        Proc3;
      when others =>
        raise Random_Error;
    end case;
    T := Calendar.Seconds ( Calendar.Clock );
    if    T - S >= 1.0 then
      S := S + 1.0;
      Random_Display;
    end if;
  end loop;
end Profiler_Test;
